// Proof of concept plastic pellets to powder grinder
// More on https://HomoFaciens.de

$fn=100;

blender_do = 82;
blender_wall = 5;
blender_di = blender_do -2*blender_wall;
blender_h = 73;
blade_d = 50;

M3_hole = 3.5;
M3_nut_e = 6.3;
M4_hole = 4.5;
M5_hole = 5.5;
M6_hole = 6.5;
M4_nut_e = 7.66 + 0.3;
M5_nut_e = 8.79 + 0.3;
M6_nut_e = 11.05 + 0.3;
M8_nut_e = 14.38+1.5;

bb8_do = 22 + 0.5;
bb8_h = 7;

bb10_do = 30 + 0.5;
bb10_h = 9;


// Mount screws
m_dis1 = 68;
m_dis2 = 105;

// Stator
m_r1 = 20;
m_r2 = 32;

assembled = 0;
cut_model = 0;


if(assembled)
difference(){
  union(){
    color([0.9, 0.1, 0.1])bottom();

    translate([0, 0, 11])
    color([0.6, 0.6, 0.6])
    can(blender_do-11, 5, blender_h-33.5);

    translate([0, 0, 11])color([0.0, 0.6, 0.6])stator(40, 3);
    
    color([0.9, 0.9, 0.0])blade(25);
  }
  if(cut_model)
  translate([blender_do/2, 0, 0])
  cube(size=[blender_do, 300, 300], center=true);
}
else{
  bottom(bb8_do, bb8_h);  
  translate([100, -30, 0])rotate([0, 0, 90])outlet();  
}



module outlet(){
  o_wall = 2;
  o_h = 55;
  o_l = 40;
  o_do = 30;
  o_di = o_do - 4;
  difference(){
    translate([0, 0, o_h/2]){
      cylinder(d=blender_do+2*o_wall+2, h=o_h, center=true);
//      translate([blender_do/2, 0, 0])
//      cube(size=[70, blender_do*0.7, o_h], center=true);
      translate([blender_do/2-33, 0, 0])
      rotate([0, 90, 0])
      roundedRect([o_h, 50+2*o_wall, 85], 25, [1,0,1,0]);
      translate([blender_do/2+37, 0, (o_h+o_l)/2-10])
      cylinder(d=o_do, h=o_l, center=true);
      rotate([0, 0, -30])
      translate([0, blender_do/2, 0])
      cube(size=[20, 30, o_h], center=true);
    }
    // inner sieve cut
    translate([blender_do/2-33-o_wall, 0, o_h/2])
    rotate([0, 90, 0])
    roundedRect([o_h - 2 * o_wall, 50, 85], 25, [1,0,1,0]);

    translate([blender_do/2+37, 0, o_h+o_l/2])
    cylinder(d=o_di, h=o_l*2, center=true);
    
    // Outer ring
    translate([0, 0, blender_h/2])
    cylinder(d=blender_do+2, h=blender_h+0.1, center=true);

    // outer ring fixture
    rotate([0, 0, -30]){
      translate([0, blender_do/2+7.5, o_h-5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=25, center=true);
        translate([0, 0, 14])
        cylinder(d=M3_nut_e, h=15, center=true, $fn=6);
      }
      translate([0, blender_do/2+7.5, 5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=25, center=true);
        translate([0, 0, 14])
        cylinder(d=M3_nut_e, h=15, center=true, $fn=6);
      }

      translate([0, blender_do/2+7.5, o_h/2])
      cube(size=[4, blender_do/2, o_h+0.1], center=true);
    }
    
    // cooling cuts
    
    for(i=[-165:60:30])rotate([0, 0, i])
    translate([0, -blender_do/2, o_h/2])
    rotate([90, 0, 0])
    rotate([0, 0, 30])
    cylinder(d=o_h -20, h=blender_do/2, center=true, $fn=6);
    
    
  }
}

module bottom(bb_do = bb10_do, bb_h = bb10_h){
  socket_h = 11;
  socket_d = 80;
  b_h = 60;
  b_d_bot = blade_d*sqrt(2);
//  alpha = atan2(b_h, (blender_e - blade_d)/2);
  
  difference(){
    union(){
      translate([0, 0, socket_h/2])
      cylinder(d=socket_d, h=socket_h, center=true);
      roundedRect([m_dis1+15, m_dis2+15, blender_wall], 5);
    }
    // Ball bearing
    translate([0, 0, socket_h-bb_h/2])
    cylinder(d=bb_do, h=bb_h+0.1, center=true);
    // shaft cut
    translate([0, 0, socket_h/2])
    cylinder(d=bb_do-5, h=socket_h+0.1, center=true);
    
    // Can mount holes
    for(i=[0:60:300])rotate([0, 0, i]){
      translate([m_r1, 0, socket_h/2])
      cylinder(d=M4_hole, h=socket_h+0.1, center=true);
      hull(){
        translate([m_r1, 0, socket_h/2-2])
        cylinder(d=M4_hole, h=socket_h, center=true);
        translate([m_r1, 0, socket_h/2-4])
        rotate([0, 0, 30])
        cylinder(d=M4_nut_e, h=socket_h, center=true, $fn=6);
      }
    }

    // Stator mount holes
    for(i=[0:1:11])rotate([0, 0, i*30]){
      translate([m_r2-i*0.24, 0, socket_h/2])
      cylinder(d=M6_hole, h=socket_h+0.1, center=true);
      translate([m_r2-i*0.24, 0, socket_h])
      rotate([0, 0, 30])
      cylinder(d=M6_nut_e, h=2*5.25, center=true, $fn=6);
    }
    
    
    // Mount holes
    translate([m_dis1/2, m_dis2/2, blender_wall/2])
    cylinder(d=M4_hole, h=blender_wall+0.1, center=true);
    translate([-m_dis1/2, m_dis2/2, blender_wall/2])
    cylinder(d=M4_hole, h=blender_wall+0.1, center=true);
    translate([-m_dis1/2, -m_dis2/2, blender_wall/2])
    cylinder(d=M4_hole, h=blender_wall+0.1, center=true);
    translate([m_dis1/2, -m_dis2/2, blender_wall/2])
    cylinder(d=M4_hole, h=blender_wall+0.1, center=true);
  }
}

module blade(blade_h = 7){
  blade_s_h = 20;
  blade_shaft = 8;
  
  translate([0, 0, blade_s_h/2])
  cylinder(d=blade_shaft, h=blade_s_h, center=true);
  translate([0, 0, blade_s_h+blade_h/2]){
    for(i=[0:90:270])rotate([0, 0, i])
    hull(){
      translate([0, blade_d/2, 0])
      cube(size=[0.1, 0.1, blade_h], center=true);
      cylinder(d=20, h=blade_h, center=true);
    }
  }

}

module stator(s_h = 40, edges = 3){
  // stator
  for(i=[0:1:11])rotate([0, 0, i*30]){
    translate([0, 0, 2.5])
    rotate([90, 0, 0])
    cylinder(d=M6_hole, h=blade_d, center=true);
    translate([m_r2-i*0.24, 0, s_h/2])
    rotate([0, 0, 180])
    cylinder(d=M6_hole, h=s_h, center=true, $fn=edges);
    translate([m_r2-i*0.24, 0, 3])
    cylinder(d=M6_nut_e, h=6, center=true, $fn=6);
  }  
}

module can(c_d = blender_do, c_wall = 1, c_h = blender_h){
  translate([0, 0, c_h/2])
  difference(){
    union(){
      cylinder(d=c_d, h=c_h, center=true);
    }
    translate([0, 0, c_wall])
    cylinder(d=c_d-2*c_wall, h=c_h, center=true);

    // Stator mount holes
    for(i=[0:1:11])rotate([0, 0, i*30]){
      translate([m_r2-i*0.24, 0, -blender_h/2])
      cylinder(d=M6_hole, h=5.1, center=true);
    }

    translate([0, 0, -c_h/2])
    cylinder(d=10.5, h=5.1, center=true);

  }
}



module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}
